% Author: Naeem
% Date: 11/30/2004

% Distribute the list into 1 sequences
  distribute(C, N, T) :- add_zero(C, [], N, Reversed), reverse(Reversed, T).
  
% Add zero but preserve space for distribution
  add_zero([], D, 0, D).
  add_zero(C, D, N, T) :- N2 is N - 1, N2 >= 0, least_size(C, S), N2 >= S,
                          add_zero(C, [0|D], N2, T).
  add_zero([X|L], D, N, T) :- N2 is N - X, add_first_one(X, D, DNew),
                              add_zero(L, DNew, N2, T).

% Keeper to not have adjacent sequence of 1s
  add_first_one(X, [0|D], DNew) :- add_one(X, [0|D], DNew).
  add_first_one(X, [], DNew) :- add_one(X, [], DNew).

% Add 1 sequence
  add_one(0, D, D).
  add_one(X, D, [1|D2]) :- X2 is X - 1, X2 >= 0, add_one(X2, D, D2).

% Compute sum of the elements of the list plus intermediate 0s
  least_size(L, T) :- compute_sum(L, -1, T).

  compute_sum([], S, S).
  compute_sum([X|L], S, T) :- Temp is S + X + 1, compute_sum(L, Temp, T).

